<?php
class SabpaisaEncryptDecrypt {
    
    private const OPENSSL_CIPHER_NAME = "aes-128-cbc";
    private const CIPHER_KEY_LEN = 16; 
    private static function fixKey($key) {
        
        if (strlen($key) < SabpaisaEncryptDecrypt::CIPHER_KEY_LEN) {
           
            return str_pad("$key", SabpaisaEncryptDecrypt::CIPHER_KEY_LEN, "0"); 
        }
        
        if (strlen($key) > SabpaisaEncryptDecrypt::CIPHER_KEY_LEN) {
           
            return substr($key, 0, SabpaisaEncryptDecrypt::CIPHER_KEY_LEN); 
        }
        return $key;
    }
    
    static function encrypt($key, $iv, $data) {
        //echo 'Data value is :' .$data;
        $encodedEncryptedData = base64_encode(openssl_encrypt($data, SabpaisaEncryptDecrypt::OPENSSL_CIPHER_NAME, SabpaisaEncryptDecrypt::fixKey($key), OPENSSL_RAW_DATA, $iv));
        $encodedIV = base64_encode($iv);
        $encryptedPayload = $encodedEncryptedData.":".$encodedIV;
        echo '$encryptedPayload value is :' .$encryptedPayload;
        return $encryptedPayload;
    }
    
    static function decrypt($key, $authiv, $data) {
        $parts = explode(':', $data); //Separate Encrypted data from iv.
        $encrypted = $parts[0];
        $iv = $parts[1];
        $decryptedData = openssl_decrypt(base64_decode($encrypted), SabpaisaEncryptDecrypt::OPENSSL_CIPHER_NAME, SabpaisaEncryptDecrypt::fixKey($key), OPENSSL_RAW_DATA, base64_decode($iv));
        return $decryptedData;
    }
}
